struct ageset_s {
	int set;
	int amount;
	worklist_p ts_list; /* of ts_p */
};
typedef struct ageset_s* ageset_p;
typedef struct ageset_s ageset_t;

typedef struct adapter_s* adapter_p;
typedef struct adapter_s adapter_t; 

struct adnode_s {
#define ADNODE_TYPE_NODE 0 
#define ADNODE_TYPE_LOOP 1
#define ADNODE_TYPE_VIRTUAL_ENTRY 2
#define ADNODE_TYPE_VIRTUAL_EXIT 3
	int type;
	adapter_p ad;
	tcfg_node_t *node;
	bitset_p dom_in, dom_out, postdom_in, postdom_out;
	int equiv;
	int loop_id; 
	int id;
};
typedef struct adnode_s adnode_t;
typedef struct adnode_s* adnode_p;

#define ADITER_OUTEDGE 0
#define ADITER_INEDGE 1
#define ADITER_GRAPH 2
#define ADITER_GRAPH_REV 3

struct aditer_s {
	int type;
	adnode_p node;
	adapter_p ad;
	tcfg_edge_t *cur_edge;
	int cur_node;
	bitset_p seen_loops;
	worklist_p virt;
	int use_entryexit;
};
typedef struct aditer_s aditer_t;
typedef struct aditer_s* aditer_p;

/* graph adapter */ 
struct adapter_s {
	tcfg_node_t **graph;
	adnode_p *adapted_nodes;
	worklist_p real_entries;
	worklist_p real_exits;
	bitset_p bs_entries, bs_exits;
	int loop_id, num_loops, num_real_nodes;
	
};

adapter_p new_adapter(tcfg_node_t **graph, int numnodes, int numloops, int loop_id);
int adnode_id(adnode_p node);
adnode_p adapter_makenode(adapter_p ad, int type, int i);
adnode_p adapter_getnode(adapter_p ad, int type, int i);
int adapter_numnodes(adapter_p ad);
adnode_p adapter_exit(adapter_p ad);
adnode_p adapter_entry(adapter_p ad);
int adapter_is_entry(adnode_p node);
int adapter_is_exit(adnode_p node);
aditer_p adnode_outedge(adnode_p node);
aditer_p adnode_inedge(adnode_p node);
int adapter_exists_node(adapter_p ad, int node_idx);
aditer_p adapter_iter(adapter_p ad);
aditer_p adapter_reviter(adapter_p ad);
int aditer_ended(aditer_p iter);
int aditer_seen_loop(aditer_p iter , int loop_id);
void aditer_mark_seen(aditer_p iter, int loop_id);
aditer_p aditer_next(aditer_p iter);
adnode_p aditer_value(aditer_p iter);

