#!/bin/bash

ROOT_DIR=~/work/Chronos-4.2
CONFIG_FILE=$ROOT_DIR/chronos-4.2/est/processor_config/arm926ejs.opt

cat $CONFIG_FILE

echo
echo "ARM binaries benchmark result:"

# Get WCET for all benchmarks in "arm_benchmarks" directory
for bench in $ROOT_DIR/arm_benchmarks/*
do
	BENCH_FILE=${bench#~/work/Chronos-4.2/arm_benchmarks/}

    # Skip multitask benchmarks
    if [ $BENCH_FILE == "robot" ]; then
        continue
    fi
    if [ $BENCH_FILE == "papabench" ]; then
        continue
    fi

	#remove the old ilp file first
	rm $bench/$BENCH_FILE.lp

	$ROOT_DIR/chronos-4.2/est/est -config $CONFIG_FILE $bench/$BENCH_FILE &> /dev/null

	echo -n "WCET of '"$BENCH_FILE"' = "

	cd $ROOT_DIR/lp_solve
	./solve $bench/$BENCH_FILE.lp | grep Value | awk '{print $5}'
	cd - &> /dev/null
done
